// jshint esversion: 6
	import * as THREE from 'three';

	// flsc
	export function flsc(length=700) {
		const flscSR = new THREE.Object3D();
		const flscContiner = new THREE.Object3D();
		const materialGrey = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		
		
		const d1geometry = new THREE.CylinderGeometry(25, 25, 500, 25);
		const d1mesh = new THREE.Mesh(d1geometry, materialGrey);
		flscContiner.add(d1mesh);				
		flscContiner.rotateX(Math.PI * 1);
			
		// esagono
		const d2geometry = new THREE.CylinderGeometry(70, 70, 100, 6);
		const d2mesh = new THREE.Mesh(d2geometry, materialGrey);
		d2mesh.position.set(0, 290, 0);
		d2mesh.rotateX(Math.PI * 1);
		d2mesh.rotateY(Math.PI * 1);
		d2mesh.rotateZ(Math.PI * 1.5);		
		flscContiner.add(d2mesh);
		
		// cil1 sotto
		const d3geometry = new THREE.CylinderGeometry(90, 90, 20, 15);
		const d3mesh = new THREE.Mesh(d3geometry, materialGrey);
		d3mesh.rotateX(Math.PI * 1);
		d3mesh.rotateY(Math.PI * 1);
		d3mesh.rotateZ(Math.PI * 1);
		d3mesh.position.set(0, 140 , 0);			
		flscContiner.add(d3mesh);		
		
		// zigrinatura
		const d4geometry = new THREE.CylinderGeometry(70, 70, 120, 15);
		const textureLoader = new THREE.TextureLoader();
		const texture = textureLoader.load('./components/flsc_texture.png');	
		texture.wrapS = texture.wrapT = THREE.RepeatWrapping;
		texture.repeat.set(5, 40);		
		const material = new THREE.MeshBasicMaterial({ map: texture });		
		const d4mesh = new THREE.Mesh(d4geometry, material);
		d4mesh.rotateX(Math.PI * 1);
		d4mesh.rotateY(Math.PI * 1);
		d4mesh.rotateZ(Math.PI * 1);
		d4mesh.position.set(0, 80 , 0);			
		flscContiner.add(d4mesh);		
		
		// cil2 sopra
		const d5geometry = new THREE.CylinderGeometry(90, 90, 20, 15);
		const d5mesh = new THREE.Mesh(d5geometry, materialGrey);
		d5mesh.rotateX(Math.PI * 1);
		d5mesh.rotateY(Math.PI * 1);
		d5mesh.rotateZ(Math.PI * 1);
		d5mesh.position.set(0, 10 , 0);			
		flscContiner.add(d5mesh);						
		
		// cil3
		const dmateria6 = new THREE.MeshLambertMaterial({color: 0x000000});
		const d6geometry = new THREE.CylinderGeometry(50, 50, 60, 15);
		const d6mesh = new THREE.Mesh(d6geometry, dmateria6);
		d6mesh.rotateX(Math.PI * 1);
		d6mesh.rotateY(Math.PI * 1);
		d6mesh.rotateZ(Math.PI * 1);
		d6mesh.position.set(0, -30 , 0);			
		flscContiner.add(d6mesh);		
		
		// box grigio
		const d7geometry = new THREE.BoxGeometry(100, 100, 100);
		const dmaterial7= new THREE.MeshLambertMaterial({color: 0x405040});
		const d7mesh = new THREE.Mesh(d7geometry, dmaterial7);
		d7mesh.position.set(0, -110, 0);		
		flscContiner.add(d7mesh);				
		
		// box contenitore arancio sotto
		const d8geometry = new THREE.BoxGeometry(120, 10, 120);
		const d8mesh = new THREE.Mesh(d8geometry, materialGrey);
		d8mesh.position.set(0, -160, 0);		
		flscContiner.add(d8mesh);				
				
		// box arancio
		const d9geometry = new THREE.BoxGeometry(100, 120, 100);
		const dmaterial9= new THREE.MeshLambertMaterial({color: 0xffA500});
		const d9mesh = new THREE.Mesh(d9geometry, dmaterial9);
		d9mesh.position.set(0, -220, 0);		
		flscContiner.add(d9mesh);	
		
		// box contenitore arancio sopra
		const d10geometry = new THREE.BoxGeometry(120, 10, 120);
		const d10mesh = new THREE.Mesh(d10geometry, materialGrey);
		d10mesh.position.set(0, -280, 0);		
		flscContiner.add(d10mesh);	
		
		//cilindro supporto
		const d11geometry = new THREE.CylinderGeometry(25, 25, 400, 25);
		const d11mesh = new THREE.Mesh(d11geometry, materialGrey);
		d11mesh.position.set(0, -120, -115);
		flscContiner.add(d11mesh);				
	
		//cilindro supporto blu
		const materialBlue = new THREE.MeshLambertMaterial({color: 0x0000ff});
		const d12geometry = new THREE.CylinderGeometry(35, 35, 100, 25);
		const d12mesh = new THREE.Mesh(d12geometry, materialBlue);
		d12mesh.position.set(0, -220, -115);
		flscContiner.add(d12mesh);
		
		//cilindro supporto2
		const d13geometry = new THREE.CylinderGeometry(25, 25, 400, 25);
		const d13mesh = new THREE.Mesh(d13geometry, materialGrey);
		d13mesh.position.set(0, -120, 115);
		flscContiner.add(d13mesh);				
	
		//cilindro supporto blu2
		const d14geometry = new THREE.CylinderGeometry(35, 35, 100, 25);
		const d14mesh = new THREE.Mesh(d14geometry, materialBlue);
		d14mesh.position.set(0, -220, 115);
		flscContiner.add(d14mesh);	
		
		// blocco supporto
		const dmaterial15 = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
		const d15geometry = new THREE.CylinderGeometry(10 /*radiusTop*/, 10 /*radiusBottom*/, 250 /*height*/, 20 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const d15mesh = new THREE.Mesh(d15geometry, dmaterial15);
		d15mesh.position.set(0, -110, 0);
		d15mesh.rotateX(Math.PI * 0.5);
		d15mesh.scale.setX(2);
		d15mesh.rotatedX = true;		
		flscContiner.add(d15mesh);				

		flscContiner.position.set(0, 280, 0);
		flscSR.add(flscContiner);
		flscSR.rotateY(Math.PI * -0.5);
		return flscSR;
	}
